% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/plant.R
\name{grow_plant_to_size}
\alias{grow_plant_to_height}
\alias{grow_plant_to_size}
\title{Grow plant to given size}
\usage{
grow_plant_to_size(plant, sizes, size_name, env, time_max = Inf,
  warn = TRUE, filter = FALSE)

grow_plant_to_height(plant, heights, env, ...)
}
\arguments{
\item{plant}{A \code{Plant} object.}

\item{sizes}{A vector of sizes to grow the plant to (increasing in
size).}

\item{size_name}{The name of the size variable within
\code{Plant$vars_phys} (e.g., height).}

\item{env}{An \code{Environment} object.}

\item{time_max}{Time to run the ODE out for -- only exists to
prevent an infinite loop (say, on an unreachable size).}

\item{warn}{Warn if requesting a plant that is too large?}

\item{filter}{Filter plants that are too large?}

\item{heights}{Heights (when using \code{grow_plant_to_height})}

\item{...}{Additional parameters passed to
\code{grow_plant_to_size}.}
}
\value{
A list with elements \code{time} (the time that a given
size was reached), \code{state} (the \emph{ode state} at these
times, as a matrix) and \code{plant} a list of plants grown to the
appropriate size.  Note that if only a single size is given,
a list of length 1 is returned.
}
\description{
Grow a plant up to particular sizes.
}

